
typedef struct _pthread_attr_t pthread_attr_t;
typedef struct _pthread_cond_t pthread_cond_t;
typedef struct _pthread_condattr_t pthread_condattr_t;
typedef struct _pthread_key_t pthread_key_t;
typedef struct _pthread_mutex_t pthread_mutex_t;
typedef struct _pthread_mutexattr_t pthread_mutexattr_t;
typedef struct _pthread_once_t pthread_once_t;
typedef struct _pthread_rwlock_t pthread_rwlock_t;
typedef struct _pthread_rwlockattr_t pthread_rwlockattr_t;
typedef struct _pthread_t pthread_t;


int   pthread_attr_destroy(pthread_attr_t *attr);
int   pthread_attr_getdetachstate(const pthread_attr_t *attr, int *detachstate);
int   pthread_attr_getguardsize(const pthread_attr_t *attr, size_t *guardsize);
int   pthread_attr_getinheritsched(const pthread_attr_t *attr,  int *inheritsched);
int   pthread_attr_getschedparam(const pthread_attr_t *attr, struct sched_param *param);
int   pthread_attr_getschedpolicy(const pthread_attr_t *attr, int *policy);
int   pthread_attr_getscope(const pthread_attr_t *attr, int *contentionscope);
int   pthread_attr_getstackaddr(const pthread_attr_t *attr, void **stackaddr);
int   pthread_attr_getstacksize(const pthread_attr_t *attr, size_t *stacksize);
int   pthread_attr_init(pthread_attr_t *attr);
int   pthread_attr_setdetachstate(pthread_attr_t *attr, int detachstate);
int   pthread_attr_setguardsize(pthread_attr_t *attr, size_t guardsize);
int   pthread_attr_setinheritsched(pthread_attr_t *attr, int inheritsched);
int   pthread_attr_setschedparam(pthread_attr_t *attr, const struct sched_param *param);
int   pthread_attr_setschedpolicy(pthread_attr_t *attr, int policy);
int   pthread_attr_setscope(pthread_attr_t *attr, int contentionscope);
int   pthread_attr_setstackaddr(pthread_attr_t *attr, void *stackaddr);
int   pthread_attr_setstacksize(pthread_attr_t *attr, size_t stacksize);
int   pthread_cancel(pthread_t thread);
void  pthread_cleanup_push(void (*routine)(void *arg), void *arg);
void  pthread_cleanup_pop(int execute);
int   pthread_cond_broadcast(pthread_cond_t * cond);
int   pthread_cond_destroy(pthread_cond_t * cond);
int   pthread_cond_init(pthread_cond_t *cond, const pthread_condattr_t *attr);
int   pthread_cond_signal(pthread_cond_t *cond);
int   pthread_cond_timedwait(pthread_cond_t *cond, pthread_mutex_t *mutex, const struct timespec *abstime);
int   pthread_cond_wait(pthread_cond_t *cond, pthread_mutex_t *mutex);
int   pthread_condattr_destroy(pthread_condattr_t *attr);
int   pthread_condattr_getpshared(const pthread_condattr_t *attr, int *pshared);
int   pthread_condattr_init(pthread_condattr_t *attr);
int   pthread_condattr_setpshared(pthread_condattr_t *attr, int pshared);
int   pthread_create(pthread_t *thread, const pthread_attr_t *attr, void *(*start_routine)(void *arg), void *arg);
int   pthread_detach(pthread_t thread);
int   pthread_equal(pthread_t t1, pthread_t t2);
void  pthread_exit(void *value_ptr);
int   pthread_getconcurrency(void);
int   pthread_getschedparam(pthread_t thread, int *policy, struct sched_param *param);
void *pthread_getspecific(pthread_key_t key);
int   pthread_join(pthread_t thread, void **value_ptr);
int   pthread_key_create(pthread_key_t *key, void (*destructor)(void *ptr));
int   pthread_key_delete(pthread_key_t key);
int   pthread_mutex_destroy(pthread_mutex_t *mutex);
int   pthread_mutex_getprioceiling(const pthread_mutex_t *mutex, int *prioceiling);
int   pthread_mutex_init(pthread_mutex_t *mutex, const pthread_mutexattr_t *attr);
int   pthread_mutex_lock(pthread_mutex_t *mutex);
int   pthread_mutex_setprioceiling(pthread_mutex_t *mutex, int prioceiling, int *old_ceiling);
int   pthread_mutex_trylock(pthread_mutex_t *mutex);
int   pthread_mutex_unlock(pthread_mutex_t *mutex);
int   pthread_mutexattr_destroy(pthread_mutexattr_t *attr);
int   pthread_mutexattr_getprioceiling(const pthread_mutexattr_t *attr, int *prioceiling);
int   pthread_mutexattr_getprotocol(const pthread_mutexattr_t *attr, int *protocol);
int   pthread_mutexattr_getpshared(const pthread_mutexattr_t *attr, int *pshared);
int   pthread_mutexattr_gettype(const pthread_mutexattr_t *attr, int *type);
int   pthread_mutexattr_init(pthread_mutexattr_t *attr);
int   pthread_mutexattr_setprioceiling(pthread_mutexattr_t *attr, int prioceiling);
int   pthread_mutexattr_setprotocol(pthread_mutexattr_t *attr, int protocol);
int   pthread_mutexattr_setpshared(const pthread_mutexattr_t *attr, int pshared);
int   pthread_mutexattr_settype(pthread_mutexattr_t *attr, int type);
int   pthread_once(pthread_once_t *once_control, void (*init_routine)(void));
int   pthread_rwlock_destroy(pthread_rwlock_t *rwlock);
int   pthread_rwlock_init(pthread_rwlock_t *rwlock, const pthread_rwlockattr_t *attr);
int   pthread_rwlock_rdlock(pthread_rwlock_t *rwlock);
int   pthread_rwlock_tryrdlock(pthread_rwlock_t *rwlock);
int   pthread_rwlock_trywrlock(pthread_rwlock_t *rwlock);
int   pthread_rwlock_unlock(pthread_rwlock_t *rwlock);
int   pthread_rwlock_wrlock(pthread_rwlock_t *rwlock);
int   pthread_rwlockattr_destroy(pthread_rwlockattr_t *attr);
int   pthread_rwlockattr_getpshared(const pthread_rwlockattr_t *attr, int *pshared);
int   pthread_rwlockattr_init(pthread_rwlockattr_t *attr);
int   pthread_rwlockattr_setpshared(pthread_rwlockattr_t *attr, int pshared);
pthread_t pthread_self(void);
int   pthread_setcancelstate(int state, int *oldstate);
int   pthread_setcanceltype(int type, int *oldtype);
int   pthread_setconcurrency(int new_level);
int   pthread_setschedparam(pthread_t thread, int policy,
                            const struct sched_param *param);
int   pthread_setspecific(pthread_key_t key, const void *value);
void  pthread_testcancel(void);
